Subject: bug#53258: closed (Re: bug#53258: Python unable to find modules within a Singularity container created with guix pack)

From: [email-masked] (GNU bug Tracking System)
Date: Sun, 21 Jan 2024 18:32:02 +0000

Your bug report

#53258: Python unable to find modules within a Singularity container created with guix pack

which was filed against the guix package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
53258: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=53258
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#53258: Python unable to find modules within a Singularity container created with guix pack
From: Maxim Cournoyer <[email-masked]>
To: Konrad Hinsen <[email-masked]>
Cc: [email-masked]
Date: Sun, 21 Jan 2024 13:31:18 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi Konrad,

Konrad Hinsen <[email-masked]> writes:

> Konrad Hinsen <[email-masked]> writes:
>
>> Patch at https://issues.guix.gnu.org/68241
>
> If you want to test it without rebuilding tons of packages, here is a
> version that grafts a patched Python onto the existing ones (as substitutes):
>
> https://codeberg.org/khinsen/guix/src/branch/graft-fix-python-sitecustomize

I've applied your patch to core-updates.  I trust that it fixed this
issue based on your own testing.

Closing; we can always reopen if we find it didn't fix every use cases
or create a fresh issue.

-- 
Thanks,
Maxim

Subject: Python unable to find modules within a Singularity container created with guix pack
From: Marek Felšöci <[email-masked]>
To: [email-masked]
Date: Fri, 14 Jan 2022 15:20:46 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello folks,

Recently, I have come around this issue. I created a Singularity container using 
the following `guix pack` command:

`guix pack -f squashfs bash coreutils python python-numpy`

Then, I run a bash shell within the container:

`singularity exec test.gz.squashfs bash`

Now, if I want to use numpy,

`python3 -m numpy`

it gives me the following error and the numpy module IS NOT found:

Error in sitecustomize; set PYTHONVERBOSE for traceback:
ValueError: 
'/gnu/store/2dyd6rlcc9m68k3mvkw86k8dygkbg025-profile/bin/../../p5fgysbcnnp8b1d91mrvjvababmczga0-python-3.9.6/lib/python3.9/site-packages' 
is not in list
/gnu/store/2dyd6rlcc9m68k3mvkw86k8dygkbg025-profile/bin/python3: No module named 
numpy

However, if I do,

`export PYTHONPATH=$GUIX_PYTHONPATH`

the numpy module IS found:

Error in sitecustomize; set PYTHONVERBOSE for traceback:
ValueError: 
'/gnu/store/2dyd6rlcc9m68k3mvkw86k8dygkbg025-profile/bin/../../p5fgysbcnnp8b1d91mrvjvababmczga0-python-3.9.6/lib/python3.9/site-packages' 
is not in list
/gnu/store/2dyd6rlcc9m68k3mvkw86k8dygkbg025-profile/bin/python3: No module named 
numpy.__main__; 'numpy' is a package and cannot be directly executed

Still, the sitecustomize error persists.

See the output of `guix describe` below (only the guix channel):

Pokolenie 3    14. január 2022 14:33:06    (súčasné)
   guix 5c5d9e5
     zdroj repozitára: https://git.savannah.gnu.org/git/guix.git
     vetva: master
     úprava: 5c5d9e5a3208fa51351c6ad8267eba3d96fa2232

Thanks,

Marek